/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 31.10.2014
Author  : PerTic@n
Company : If You Like This Software,Buy It
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
#include <string.h>

// Standard Input/Output functions
#include <stdio.h>
#define KEY !PINB.4
#define LED_BLUE PORTB.5
#define LED_RED PORTB.2
#define DOOR PORTB.2
#define BUZER PORTD.4

#define testbit(var,_bit) ((var >> _bit) & 1)     //
#define GETBIT(x,n) ((x)&1L<<(n))
//unsigned char a1,a2,a3,a4,a5,a6,a7,a8,a9,a10;
unsigned char RFID_Buffer [6];  // RFID
unsigned int num;
unsigned char RFID_Code [6];  // 

    
unsigned char crc;//,crc2;
//unsigned char Timer = 0;        //   
unsigned char data, RFIDBitCount, RFIDBufferPtr, Header, Time, RFIDFound, Rising, Direction, crc_count;

unsigned char CheckCRC(unsigned char *buffer)
{
        unsigned char i;
        crc = 0;
        for (i=0; i<5; i++){
                crc = crc ^ ( buffer[i] & 0x0F ) ^ ( ( buffer[i] >> 4 ) & 0x0F );    
        }
        if (crc != ( buffer[5] & 0x0F )) { return 0; } else { return 1; } 
}

// Timer1 input capture interrupt service routine
interrupt [TIM1_CAPT] void timer1_capt_isr(void)
{
//LED_RED=1;
        if(RFIDFound){return;}
        Time = ICR1L;
        TCNT1L = 0;
        TCNT1H = 0;
       //TIFR |= 0x20; 
        if ( Time < 7 ) { return; }
        if ( Time > 30 ) { return; }
        if ( TCCR1B == 0x84 ) { TCCR1B = 0xC4; Rising = 0;} else { TCCR1B = 0x84; Rising = 1; } //        (-) 
        if (data) {
                if ( Direction ) { //   - 
                        if (!Rising) { //    -   
                                if ((++crc_count == 5)&( RFIDBitCount < 40 )) {
                                        crc_count = 0;
                                        if (crc == 1 ) { data = 0;}  //    
                                        crc = 0;  
                                } else {  
                                        RFID_Buffer[RFIDBufferPtr] <<= 1; //  
                                        if ((++RFIDBitCount & 7) == 0) RFIDBufferPtr++; //   
                                        if (crc_count == 0) { crc = 0; } else { crc ^= 0; } //    
                                } 
                        }                                                
                } else {
                        if (Rising) { //    -   
                                if ((++crc_count == 5)&( RFIDBitCount < 40 )) {
                                        crc_count = 0;
                                        if (crc == 0) { data = 0;}  //    
                                        crc = 0;  
                                } else {  
                                        RFID_Buffer[RFIDBufferPtr] <<= 1; //  
                                        RFID_Buffer[RFIDBufferPtr] += 0x01;
                                        if ((++RFIDBitCount & 7) == 0) RFIDBufferPtr++; //   
                                        if (crc_count == 0) { crc = 1; } else { crc ^= 1; } //     
                                }
                        }                                                
                }
                if (RFIDBitCount == 45) {RFIDFound = 1; data = 0; RFIDBitCount = 0; return; } 
                if (( Time >= 16 )&(Time <= 20 )) { 
                        Direction = !Direction; //      -        
                }
        } else {   
                if (( Time >= 16 )&( Time <= 20 )&(Rising)) {  
                        if ( Header > 10 ) 
                        { 
                                data = 1;
                                Direction = 1;
                                RFIDBitCount = 0; RFIDBufferPtr = 0; crc_count = 0; Header = 0;
                                RFID_Buffer[0]=0; RFID_Buffer[1]=0; RFID_Buffer[2]=0; RFID_Buffer[3]=0; RFID_Buffer[4]=0; RFID_Buffer[5]=0;
                                
                        } 
                } else {
                        if (( Time >= 8 )&( Time <= 10 )) { Header++; 
                        } else { Header = 0; }
                }
        }         
//LED_RED=0;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here
// Input/Output Ports initialization
{
// Port B initialization
// Function: Bit7=In Bit6=In Bit5=Out Bit4=In Bit3=Out Bit2=Out Bit1=In Bit0=In 
DDRB=(0<<DDB7) | (0<<DDB6) | (1<<DDB5) | (0<<DDB4) | (1<<DDB3) | (1<<DDB2) | (0<<DDB1) | (0<<DDB0);
// State: Bit7=T Bit6=T Bit5=0 Bit4=T Bit3=0 Bit2=0 Bit1=T Bit0=T 
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);
// State: Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

// Port D initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=Out Bit3=In Bit2=In Bit1=In Bit0=In 
DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (1<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
// State: Bit7=T Bit6=T Bit5=T Bit4=0 Bit3=T Bit2=T Bit1=T Bit0=T 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
TCCR0=(0<<CS02) | (1<<CS01) | (1<<CS00);
TCNT0=0x10;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Normal top=0xFFFF
// OC1A output: Disconnected
// OC1B output: Disconnected
// Noise Canceler: On
// Input Capture on Rising Edge
// Timer Period: 2,0972 s
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: On
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
TCCR1B=(1<<ICNC1) | (1<<ICES1) | (0<<WGM13) | (0<<WGM12) | (1<<CS12) | (0<<CS11) | (0<<CS10);
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x12;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: CTC top=OCR2A
// OC2 output: Toggle on compare match
// Timer Period: 4,625 us
// Output Pulse(s):
// OC2 Period: 9,25 us Width: 4,625 us
ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (1<<COM20) | (1<<CTC2) | (0<<CS22) | (0<<CS21) | (1<<CS20);
TCNT2=0x00;
OCR2=32;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(0<<OCIE2) | (0<<TOIE2) | (1<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (0<<TOIE0);

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: Off
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=(0<<RXC) | (0<<TXC) | (0<<UDRE) | (0<<FE) | (0<<DOR) | (0<<UPE) | (0<<U2X) | (0<<MPCM);
UCSRB=(0<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (0<<RXEN) | (1<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);
UCSRC=(1<<URSEL) | (0<<UMSEL) | (0<<UPM1) | (0<<UPM0) | (0<<USBS) | (1<<UCSZ1) | (1<<UCSZ0) | (0<<UCPOL);
UBRRH=0x00;
UBRRL=0x33;

// Analog Comparator initialization
// Analog Comparator: Off
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
SFIOR=(0<<ACME);

// ADC initialization
// ADC disabled
ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);

// SPI initialization
// SPI disabled
SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);

// TWI initialization
// TWI disabled
TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);
}
// Global enable interrupts
#asm("sei")

LED_BLUE=1;

//#define ROHOS_MODE

while (1)
 {
char z=0;      // Place your code here
z=0;   
      
  if (RFIDFound) {
                  ;
                  memcpy(RFID_Code,RFID_Buffer,6);
        
        
        if ( CheckCRC(RFID_Code) ) {   
                char crc_FS2044 ;
//                LED_RED=1;LED_BLUE=0;
                crc_FS2044=0;
                num = (unsigned int)(RFID_Code[3] << 8)|RFID_Code[4];
                
                #ifdef ROHOS_MODE //     Rohos logon key
				  //( easyident).  . ,   
				  //ROHOS ..
                
                for (z=0;z<5;z++) {
                                   crc_FS2044=crc_FS2044+(RFID_Code[z]>>4);
                                   crc_FS2044=crc_FS2044+(RFID_Code[z]&0b00001111); 
                                   }

                if(PINC.2==0){
                            LED_RED=1;LED_BLUE=0;
                            delay_ms(100);
                            printf("%02X%02X%02X%02X%02X%01X\r\n",RFID_Code[0],RFID_Code[1],RFID_Code[2],RFID_Code[3],RFID_Code[4],crc_FS2044&00001111);
                            delay_ms(100);
                            LED_BLUE=1;LED_RED=0;
                            }
                            
                #else      //   RFID Credential.  . 
                            LED_RED=1;LED_BLUE=0;
                            delay_ms(50);
                            printf("ID:%u %u %u %u %u\r\n",RFID_Code[0],RFID_Code[1],RFID_Code[2],RFID_Code[3],RFID_Code[4]);
                            delay_ms(200); 
                            //printf(">");
                            LED_BLUE=1;LED_RED=0;
                
                
                #endif
                
        }
    
   
    
    
    RFIDFound = 0;
    }                                                                                                            
 }
}
